'use strict'

exports.__esModule = true
exports.default = exports.useDebounce = exports.useDebounceCallback = void 0

var _react = require('react')

var _utils = require('@render-props/utils')

const useDebounceCallback = (fn, wait = 100, immediate = true) => {
  const timeout = (0, _react.useRef)(null)
  const next = (0, _react.useCallback)(
    args => {
      fn.apply(void 0, args)
      timeout.current = null
    },
    [fn]
  )

  function _ref() {
    return next(arguments)
  }

  function _ref2() {
    return (
      timeout.current !== null &&
      (0, _utils.clearRequestTimeout)(timeout.current)
    )
  }

  return (0, _react.useCallback)(
    function() {
      if (timeout.current === null && immediate === true) {
        next(arguments)
      } else if (timeout.current !== null) {
        ;(0, _utils.clearRequestTimeout)(timeout.current)
      }

      timeout.current = (0, _utils.requestTimeout)(_ref, wait)
      return _ref2
    },
    [next, wait]
  )
}

exports.useDebounceCallback = useDebounceCallback

const useDebounce = (initialState, wait, immediate) => {
  const [state, setState] = (0, _react.useState)(initialState)
  return [state, useDebounceCallback(setState, wait, immediate)]
}

exports.useDebounce = useDebounce
var _default = useDebounce
exports.default = _default
